<template>
  <div :class="classes" @dragover="onDragOver" @dragleave="onDragLeave" @drop="onDrop" @click="onClick">
    <!-- Hidden input for upload -->
    <input ref="input" type="file" hidden multiple @change="onChange" />

    <transition name="fade" mode="out-in">
      <!-- Placeholder -->
      <div v-if="files.length === 0" key="placeholder">
        <!-- Icon -->
        <v-icon class="upload__icon" :color="dragging ? 'primary' : 'grey'">mdi-cloud-upload-outline</v-icon>

        <!--  Text -->
        <div class="upload__text">
          {{ $t('upload.drop') }}<u class="upload__select" @click="onClick">{{ $t('upload.browse') }}</u>
        </div>
      </div>

      <!-- File selected -->
      <div v-else key="selected">
        <!-- Icon -->
        <v-icon class="upload__icon" color="primary">mdi-file-outline</v-icon>

        <div v-for="(file, index) in files" :key="index">
          <!-- Text -->
          <div class="upload__text">
            {{ file.name }}
            <!-- Remove button -->
            <v-btn class="upload__button" color="primary" icon :ripple="false" @click.stop="onRemoveFile(file)">
              <v-icon>mdi-close</v-icon>
            </v-btn>
          </div>
        </div>
      </div>
    </transition>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, ref } from '@vue/composition-api'
import { useVModel } from '@vueuse/core'

export default defineComponent({
  props: {
    // v-model value
    value: {
      type: Array,
      default: () => [],
    },
  },
  setup(props, { emit }) {
    // v-model value
    const files = useVModel(props, 'value', emit, { eventName: 'input' })

    // Input element binding
    const input = ref<HTMLInputElement | null>(null)

    // If the user is holding a file over the upload
    const dragging = ref(false)

    // Style classes for the root component
    const classes = computed(() =>
      ['upload', dragging.value ? 'upload--dragged' : '', files.value ? 'upload--selected' : ''].join(' ')
    )

    // File input change event handler
    function onChange() {
      const fileBuffer = []

      if (input.value?.files) {
        Array.prototype.push.apply(fileBuffer, Array.from(input.value.files))
      }
      // Make sure a file is present
      if (fileBuffer.length > 0) {
        files.value = fileBuffer
      }
    }

    // Drag enter event handler
    function onDragOver(event) {
      event.preventDefault()

      dragging.value = true
    }

    // Drag leave event handler
    function onDragLeave(event) {
      event.preventDefault()

      dragging.value = false
    }

    // Drop event handler
    function onDrop(event) {
      event.preventDefault()

      // Manually set the file for the input
      if (input.value) {
        input.value.files = event.dataTransfer.files
      }

      // Manually call the "onChange" event
      onChange()

      // Reset the "dragging" value
      dragging.value = false
    }

    // Click event handler for manual file selection
    function onClick() {
      // Manually simulate a click on the file input
      input.value?.click()
    }

    function onRemoveFile(file) {
      const ind = files.value.indexOf(file)
      files.value.splice(ind, 1)
    }

    return {
      files,
      input,
      dragging,
      classes,
      onChange,
      onDragOver,
      onDragLeave,
      onDrop,
      onClick,
      onRemoveFile,
    }
  },
})
</script>

<style lang="scss" scoped>
.upload {
  background: rgba(249, 249, 249, 0.8);
  border: 2px dashed rgba(157, 157, 157, 0.5);
  border-radius: 3px;
  text-align: center !important;
  cursor: pointer;
  transition: all $secondary-transition;
  padding: 32px;
  position: relative;

  &--dragged {
    background: rgba($primary, 0.1);
    border-color: $primary;
  }

  &__icon {
    font-size: 70px !important;
  }

  &__text {
    font-weight: 500;
    font-size: 16px;
    color: grey;
    margin-top: 16px;
    transition: color $secondary-transition;

    .upload--selected &,
    .upload--dragged & {
      color: $primary !important;
    }
  }

  &__button {
  }
}
</style>
